C     DYANA version. Mauro A. Cremonini 06.12.96


      SUBROUTINE PSEGRAD(N,G)
      use cyanadata
      use crystaldata ! parametri per lo stato solido
C
      implicit double precision (a-h,o-z)

      INCLUDE 'pse.incl'

      double precision Ri(3), Rij(3), Ril(3)
      double precision,dimension(3) :: Qij,Qij_star,
     *                      Qij_SUM,Fij_SUM,Gij_SUM,Hij_SUM,
     *                      Lij_SUM,Mij_SUM,Nij_SUM, Qil,Qil_star,
     *                      Lij_TMP,Nij_TMP,GG
      double precision, dimension(3,MAXDIPcry,MAXTENScry-1) :: Fij,Gij,
     * Hij,Lij,Mij,Nij,QQij
      double precision OrMx1(3,3),MeMx1(3,3), tmpvec(3)
c
c
C
      DIMENSION G(N),
     *          RPSE(6,MAXDIP,MAXTENS),APSE(6,-1:MAXDIP),JPSE(MAXDIP)
C	ATTENZIONE, in APSE era MAXD
      IGP=0
!	print*, 'entro'

!-----------------------------------------------------------------------
!		if Solidstate
!-----------------------------------------------------------------------
       if (crydipflag) then

      ! I need to calculate QX, QY, QZ, QI, Qij, Qij_star, the suns over l of various products,
      ! calculate Fij, Gij, Hij, Lij, Mij, Nij, 
      Fij=0.
      Gij=0.
      Hij=0.
      Nij=0.
      Lij=0.
      QQij=0.

      DO j=1,cryntenso-1 ! one tensor is the crystal Origin
        I=1
        DO 70 WHILE (I.LE.NDIPcry) ! i = nucleus index
          IF (cryDIP2FLAG(I)) THEN
c
         if((crynute(i).eq.j)) then
c
            NPROT1=cryNPROT(I)
            Fij_SUM=0. ! suffix _SUM indicate over "i" for "NPROT1"
            Gij_SUM=0.
            Hij_SUM=0.
            Lij_SUM=0.
            Mij_SUM=0.
            Nij_SUM=0.
            Qij_SUM=0.
            DO 65 m=1,NPROT1
              i_ker=cryINDXDIP(I)
			  ! nucelus coordinates in cyana frame
              Ri(:)=coo(:,i_ker)
			  ! 
              Rij=Ri-RepMet(j,0)%C
			  ! gradient tokens calculation
              Rij2=Rij(1)**2+Rij(2)**2+Rij(3)**2 
              Rij_mod=SQRT(Rij2) 
              Rij5=Rij_mod**5
              AXRij=DOT_PRODUCT(RepMet(j,0)%AX,Rij)
              AYRij=DOT_PRODUCT(RepMet(j,0)%AY,Rij)
              AZRij=DOT_PRODUCT(RepMet(j,0)%AZ,Rij)
              AXRij2=AXRij**2
              AYRij2=AYRij**2
              AZRij2=AZRij**2
              QXij=2*cryA2DIP(j)*AXRij/Rij5
              QYij=-2*cryA2DIP(j)*AYRij/Rij5
              QZij=6*cryA1DIP(j)*AZRij/Rij5
              QIij=-(cryA1DIP(j)* (2+5*(3*AZRij2-Rij2) /Rij2) +
     *             cryA2DIP(j)* (5*(AXRij2-AYRij2)/Rij2) )/Rij5
              Qij_star(:)=QXij*RepMet(j,0)%AX(:)+QYij*RepMet(j,0)%AY(:)
     *                                          +QZij*RepMet(j,0)%AZ(:) 
              Qij(:)=Qij_star(:)+QIij*Rij(:)
              Fij_SUM=Fij_SUM+(Ri.X.Qij) ! .X. is the vector product, defined in crystaldata
              Qij_SUM=Qij_SUM+Qij

              ! for replicated metals:
              Lij_TMP=0. ! suffix _TMP is for sum over "l"
              Nij_TMP=0.

              do l=1,nRepMet
              Ril=Ri-RepMet(j,l)%C

			  ! gradient tokens calculation:
              Ril2=Ril(1)**2+Ril(2)**2+Ril(3)**2 
              Ril_mod=SQRT(Ril2) 
              Ril5=Ril_mod**5
              AXRil=DOT_PRODUCT(RepMet(j,l)%AX,Ril)
              AYRil=DOT_PRODUCT(RepMet(j,l)%AY,Ril)
              AZRil=DOT_PRODUCT(RepMet(j,l)%AZ,Ril)
              AXRil2=AXRil**2
              AYRil2=AYRil**2
              AZRil2=AZRil**2
              QXil=2*cryA2DIP(j)*AXRil/Ril5
              QYil=-2*cryA2DIP(j)*AYRil/Ril5
              QZil=6*cryA1DIP(j)*AZRil/Ril5
              QIil=-5*(cryA1DIP(j)* (0.4+(3*AZRil2-Ril2) /Ril2) +
     *             cryA2DIP(j)* ((AXRil2-AYRil2)/Ril2) )/Ril5
               Qil(:)=QXil*RepMet(j,l)%AX(:)+QYil*RepMet(j,l)%AY(:)+
     *                              QZil*RepMet(j,l)%AZ(:)+QIil*Ril(:)
               Qil_star(:)=QXil*RepMet(j,0)%AX(:)+QYil*RepMet(j,0)%AY(:)
     *                              +QZil*RepMet(j,0)%AZ(:)
              Nij_TMP=Nij_TMP+Qil
              Lij_TMP=Lij_TMP+MATMUL(CyRotInv(l,:,:),Qil)
              Gij_SUM=Gij_SUM+(MATMUL(CyRotInv(l,:,:),Ril).X.Qil_star)

              end do
              ! end replicated metals

              Lij_SUM=Lij_SUM+Lij_TMP 
			  Nij_SUM=Nij_SUM+Nij_TMP
			  Mij_SUM=Mij_SUM+(Nij_TMP.X.Ri)
              I=I+1
 65         CONTINUE
            IGP=IGP+1
            JPSE(IGP)=i_ker
            I1=I-1
            D=2*cryWDIP*cryWPROT(I1)*cryPVIOL(I1)/NPROT1

            Fij(:,IGP,j)=D*Fij_SUM
            QQij(:,IGP,j)=D*Qij_SUM
            Gij(:,IGP,j)=D*Gij_SUM
            Hij(:,IGP,j)=D*(RepMet(j,0)%C.X.Lij_SUM)
            Lij(:,IGP,j)=D*Lij_SUM
            Mij(:,IGP,j)=D*Mij_SUM
            Nij(:,IGP,j)=D*Nij_SUM

           else
             i=i+1
           endif 
c
c
          ELSE
            I=I+1
          ENDIF ! if "dip2flag"

 70     CONTINUE ! change nucleus i
      END DO ! change metal

      DO 75 K=1,6
        DO 75 I=-1,N
          APSE(K,I)=0.0 
 75   CONTINUE

      ! ------------------------------------------------------------
      !   orientation origin-inner metal
      ! ------------------------------------------------------------
        if (OMflag) then

          OrMx1(:,1) = Orig%AX
          OrMx1(:,2) = Orig%AY
          OrMx1(:,3) = Orig%AZ

          MeMx1(:,1) = RepMet(1,0)%AX
          MeMx1(:,2) = RepMet(1,0)%AY
          MeMx1(:,3) = RepMet(1,0)%AZ

          I3=IAUNIT(cryIMET(cryntenso)) ! origin index
          I2=IAUNIT(cryIMET(1)) ! metal index

          do ii=1,3
            do jj=1,3
            tmpvec=2*OMweight*OMviol(ii,jj)*(MeMx1(:,ii).X.OrMx1(:,jj))
              APSE(1:3,I2)=APSE(1:3,I2) + tmpvec
              APSE(1:3,I3)=APSE(1:3,I3) - tmpvec
            end do
          end do

        end if          
      ! ------------------------------------------------------------
      !   end orientation origin-inner metal
      ! ------------------------------------------------------------

      I3=IAUNIT(cryIMET(cryntenso)) ! origin index
      DO j=1,cryNTENSO-1
        I2=IAUNIT(cryIMET(j)) ! metal index
        DO i=1,IGP ! 
          I1=IAUNIT(JPSE(I)) ! nucleus index
            APSE(1:3,I1)=APSE(1:3,I1)+Fij(:,i,j)-Mij(:,i,j)
            APSE(4:6,I1)=APSE(4:6,I1)-QQij(:,i,j)-Nij(:,i,j)
            APSE(1:3,I2)=APSE(1:3,I2)-Fij(:,i,j)-Hij(:,i,j)-Gij(:,i,j)
            APSE(4:6,I2)=APSE(4:6,I2)+QQij(:,i,j)+Lij(:,i,j)
            APSE(1:3,I3)=APSE(1:3,I3)+Mij(:,i,j)+Hij(:,i,j)+Gij(:,i,j)
            APSE(4:6,I3)=APSE(4:6,I3)+Nij(:,i,j)-Lij(:,i,j)
        ENDDO
      ENDDO


      DO 77 I=N,2,-1 
        J=IPREV(I) ! IPREV(I) is the dihedral angle index
        DO 77 K=1,6
          APSE(K,J)=APSE(K,J)+APSE(K,I) 
 77   CONTINUE

      do I=1,N
        I2=IDA(2,I) ! index of 2° nucelus defining the dihedral angle I
        I3=IDA(3,I) ! index of 3° nucelus defining the dihedral angle I
        C1=coo(1,I3) 
        C2=coo(2,I3)
        C3=coo(3,I3)
        S1=coo(1,I2)-C1 ! S= -E_k (note: is the vector, not the unit vector, and it is already negative)
        S2=coo(2,I2)-C2
        S3=coo(3,I2)-C3

		! G(I) is the derivative of TF with respect dihedral angle I
        G(I)=G(I)+DINVBL(I)*(      					! dinvbl() inverse bond length, to transform E_k in e_k
     *                 - S1*APSE(1,I) -
     *                   S2*APSE(2,I) -
     *                   S3*APSE(3,I) -
     *                   (S2*C3-S3*C2)*APSE(4,I) -	
     *                   (S3*C1-S1*C3)*APSE(5,I) -	
     *                   (S1*C2-S2*C1)*APSE(6,I)
     *                  )

      end do

      end if ! if crydipflag
       
!-----------------------------------------------------------------------
!      else ! if not SolidState (end of solid state)

      if (dipflag) then
!-----------------------------------------------------------------------
      IGP = 0

      DO IQ=1,NTENSO*NDTENSO
        CMEX=coo(1,IMET(IQ))
        CMEY=coo(2,IMET(IQ))
        CMEZ=coo(3,IMET(IQ))
        AXX=coo(1,IAX(IQ))-CMEX
        AXY=coo(2,IAX(IQ))-CMEY
        AXZ=coo(3,IAX(IQ))-CMEZ
        AYX=coo(1,IAY(IQ))-CMEX
        AYY=coo(2,IAY(IQ))-CMEY
        AYZ=coo(3,IAY(IQ))-CMEZ
        AZX=coo(1,IAZ(IQ))-CMEX
        AZY=coo(2,IAZ(IQ))-CMEY
        AZZ=coo(3,IAZ(IQ))-CMEZ
        I=1
c       IGP=0
        DO 390 WHILE (I.LE.NDIP) 
          IF (DIP2FLAG(I)) THEN
c
c   Antonio. Check it's the appropriate tensor
c

         if((ntenso.ne.1).or.(nute(i).eq.iq)) then
c
!         if((nute(i).eq.iq)) then
c
            NPROT1=NPROT(I)
            TMP1=0.
            TMP2=0.
            TMP3=0.
            TMP4=0.
            TMP5=0.
            TMP6=0.  
            DO 385 L=1,NPROT1
              J=INDXDIP(I)
              HX=coo(1,J)
              HY=coo(2,J)
              HZ=coo(3,J)
              OHX=HX-CMEX
              OHY=HY-CMEY
              OHZ=HZ-CMEZ
              OH2=OHX**2+OHY**2+OHZ**2 
              OH=SQRT(OH2)
              OH5=OH**5
              AXOH=AXX*OHX+AXY*OHY+AXZ*OHZ
              AYOH=AYX*OHX+AYY*OHY+AYZ*OHZ
              AZOH=AZX*OHX+AZY*OHY+AZZ*OHZ
              AXOH2=AXOH**2
              AYOH2=AYOH**2
              AZOH2=AZOH**2
              QX=2*A2DIP(IQ)*AXOH/OH5
              QY=-2*A2DIP(IQ)*AYOH/OH5
              QZ=6*A1DIP(IQ)*AZOH/OH5
              QI=-(A1DIP(IQ)* (2+5*(3*AZOH2-OH2) /OH2) +
     *             A2DIP(IQ)* (5*(AXOH2-AYOH2)/OH2) )/OH5
              BX=QX*AXX+QY*AYX+QZ*AZX+QI*OHX
              BY=QX*AXY+QY*AYY+QZ*AZY+QI*OHY
              BZ=QX*AXZ+QY*AYZ+QZ*AZZ+QI*OHZ
              TMP1=TMP1+(BY*HZ-BZ*HY)
              TMP2=TMP2+(BZ*HX-BX*HZ)
              TMP3=TMP3+(BX*HY-BY*HX)
              TMP4=TMP4+BX
              TMP5=TMP5+BY
              TMP6=TMP6+BZ
C             the reversal of sign in the above is due to the  (I2-I3) direction
C             of the "e(a)" unit vector (see S1-S3 below).
              I=I+1
 385         CONTINUE
            IGP=IGP+1
            JPSE(IGP)=J
            I1=I-1
            D=2*WDIP*WPROT(I1)*PVIOL(I1)/NPROT1
            RPSE(1,IGP,IQ)=D*TMP1
            RPSE(2,IGP,IQ)=D*TMP2
            RPSE(3,IGP,IQ)=D*TMP3
            RPSE(4,IGP,IQ)=D*TMP4
            RPSE(5,IGP,IQ)=D*TMP5
            RPSE(6,IGP,IQ)=D*TMP6
c
c   Antonio
c
           else
             i=i+1
           endif
c
c
          ELSE  
            I=I+1
          ENDIF
		  
 390     CONTINUE

      ENDDO 

      DO 420 K=1,6
        DO 420 I=-1,N
          APSE(K,I)=0.0 
  420 CONTINUE

      DO IQ=1,NTENSO*NDTENSO
        I2=IAUNIT(IMET(IQ))
        DO I=1,IGP
          I1=IAUNIT(JPSE(I))
          DO K=1,6
            T=RPSE(K,I,IQ)
            APSE(K,I1)=APSE(K,I1)+T 
            APSE(K,I2)=APSE(K,I2)-T 
          ENDDO
        ENDDO
      ENDDO

      DO 440 I=N,1,-1
        J=IPREV(I) 
        DO 440 K=1,6
          APSE(K,J)=APSE(K,J)+APSE(K,I)
                                       
 440  CONTINUE

      DO 460 I=1,N
        I2=IDA(2,I)
        I3=IDA(3,I)
        C1=coo(1,I3)
        C2=coo(2,I3)
        C3=coo(3,I3)
        S1=coo(1,I2)-C1 
        S2=coo(2,I2)-C2
        S3=coo(3,I2)-C3

		
        G(I)=G(I)+DINVBL(I)* (
     *                   S1*APSE(1,I) +
     *                   S2*APSE(2,I) +
     *                   S3*APSE(3,I) +
     *                   (S2*C3-S3*C2)*APSE(4,I) +
     *                   (S3*C1-S1*C3)*APSE(5,I) +
     *                   (S1*C2-S2*C1)*APSE(6,I)
     *                  )


  460   CONTINUE

!-----------------------------------------------------------------------
!      endif		! end if SolidState
      end if        ! end if dipflag
!-----------------------------------------------------------------------
        
      RETURN
      END
